#!/usr/bin/perl

########################################
# Script by Matt of Bumderland
# http://www.bumderland.com
# bookbaghead@hotmail.com
########################################

########################################
# Display Header
########################################
print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document

########################################
# Read Universal Settings
########################################
open(SET,"uniset.dat");
$set = <SET>;
close(SET);
@unisettings = split(/,/,$set);
$nogame = @unisettings[0];
$defaultgame = @unisettings[1];

########################################
# Read Query String
########################################
if(length($ENV{'QUERY_STRING'}) > 3)
{
	@qpairs = split(/&/,lc($ENV{'QUERY_STRING'}));  #  splits up each pair (name=value)
	foreach $pair(@qpairs)  #  starts loop to store each individual value
	{
		($name,$value) = split(/=/,$pair);  #  splits the name=value string into a string for each field
		$value =~ s/\+/ /g;  # converts plusses to spaces
		$value =~ s/%(..)/pack("c",hex($1))/ge;  #  converts special symbols (%20 to whatever)
		$query{$name} = "$value";  #  defines form field
	}
}

########################################
# Get Variables from Form
########################################
if($ENV{'CONTENT_LENGTH'} > 3)
{
	read (STDIN, $unformatted, $ENV{'CONTENT_LENGTH'});  #  stores the unformated form data
	@pairs = split(/&/,lc($unformatted));  #  splits up each pair (name=value)
	foreach $pair(@pairs)  #  starts loop to store each individual value
	{
		($name,$value) = split(/=/,$pair);  #  splits the name=value string into a string for each field
		$value =~ s/\+/ /g;  # converts plusses to spaces
		$value =~ s/%(..)/pack("c",hex($1))/ge;  #  converts special symbols (%20 to whatever)
		$query{$name} = "$value";  #  defines form field
	}
}

########################################
# Check for game field
########################################
if(!(exists $query{'game'}))
{
	if($defaultgame ne "")
	{
		$query{'game'} = $defaultgame."/";
	}
	else
	{
		$query{'game'} = "";
	}
}
else
{
	if($query{'game'} ne "")
	{
		$query{'game'} = $query{'game'}."/";
	}
}

########################################
# Check to make sure that game exists
########################################
if(!(-e "$query{'game'}scores.dat"))
{
	if($defaultgame ne "")
	{
		$query{'game'} = $defaultgame."/";
	}
	else
	{
		$query{'game'} = "";
	}
	if(!(-e "$query{'game'}scores.dat"))  #If the game still doesn't exist
	{
		$query{'game'} = "";
	}
}

########################################
# Get Field Data
########################################
open(FIELDS,"$query{'game'}fields.dat");
$properties = <FIELDS>;
close(FIELDS);
($fields,$properties) = split(/\|/,$properties);
@fields = split(/,/,$fields);
@properties = split(/,/,$properties);
$count = 0;
foreach $field (@fields)
{
	$properties{$field} = $properties[$count];
	$number{$field} = $count;  #  I need to know the numbers of cerain fields.
	$count++;
}
@properties = ();

########################################
# Read Settings
########################################
open(SET,"$query{'game'}set.dat");
$set = <SET>;
close(SET);
@settings = split(/,/,$set);
$query = @settings[0];

########################################
# Read Display Settings
########################################
if ($query{'show'} =~ "-" && length($query{'show'}) > 2)
{
	($first,$last) = split(/-/,$query{'show'});
	$first = $first - 1;  #  This allows me to make the first score one instead on zero
	$last = $last - 1;  #  Must be done because of previous line
}
else
{
	$query{'show'} = $query;
	if ($query{'show'} =~ "-" && length($query{'show'}) > 2)
	{
		($first,$last) = split(/-/,$query{'show'});
		$first = $first - 1;  #  This allows me to make the first score one instead of zero
		$last = $last - 1;  #  Must be done because of previous line
	}
	else
	{
		$query{'show'} = "1-10";
		$first = 0;
		$last = 9;
	}
}


########################################
# Read Databases
########################################
if(substr($query{'type'},0,1) eq "a")  #  Open all-time high scores
{
#  Main
open(MAIN, "$query{'game'}amain.dat");
while(<MAIN>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	$main = $main."$row\n";
}
close(MAIN);
#  Entries
open(ENT, "$query{'game'}aent.dat");
while(<ENT>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	$ent = $ent."$row\n";
}
close(ENT);
#  Scores
open(SCORES, "$query{'game'}ascores.dat");
while(<SCORES>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	push(@scores,$row);
}
close(SCORES);
}
else
{
#  Main
open(MAIN, "$query{'game'}main.dat");
while(<MAIN>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	$main = $main."$row\n";
}
close(MAIN);
#  Entries
open(ENT, "$query{'game'}ent.dat");
while(<ENT>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	$ent = $ent."$row\n";
}
close(ENT);
#  Scores
open(SCORES, "$query{'game'}scores.dat");
while(<SCORES>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	push(@scores,$row);
}
close(SCORES);
}

########################################
# Sort Scores
########################################
if(!(exists $query{'sort'})){$query{'sort'} = $fields[0];}
if (($number{$query{'sort'}} ne "0") || (substr($query{'order'},0,1) eq "a"))
{	
	if($properties{$query{'sort'}} == 0)
	{
		if(substr($query{'order'},0,1) eq "a")
		{
			@scores = reverse sort sort_strings @scores;
		}
		else
		{
			@scores = sort sort_strings @scores;
		}
	}
	else
	{
		if(substr($query{'order'},0,1) eq "a")
		{
			@scores = reverse sort sort_numbers @scores;
		}
		else
		{
			@scores = sort sort_numbers @scores;
		}
	}
}

########################################
# Set Next and Previous
########################################
$difference = $last - $first;
$amount = $difference + 1;
$numberofscores = scalar(@scores);
$highprevious = $first;  #  I do not subtract 1 because I would need to undo it later anyway.
$lowprevious = $first - $difference;
if($lowprevious <= 0)
{
	$lowprevious = 1;
	if($highprevious <= 0)
	{
		$previous = "Previous $amount Scores";
	}
	else
	{
		$previous = "\<a href=\"display.cgi?show=$lowprevious-$highprevious\&sort=$query{'sort'}\&game=".substr($query{'game'},0,-1)."\&order=$query{'order'}\&type=$query{'type'}\"\>Previous $amount Scores\</a\>";
	}
}
else
{
	$previous = "\<a href=\"display.cgi?show=$lowprevious-$highprevious\&sort=$query{'sort'}\&game=".substr($query{'game'},0,-1)."\&order=$query{'order'}\&type=$query{'type'}\"\>Previous $amount Scores\</a\>";
}
$lownext = $last + 2;
$highnext = $lownext + $difference;
if($highnext > $numberofscores)
{
	$highnext = $numberofscores;
	if($lownext > $numberofscores)
	{
		$next = "Next $amount Scores";
	}
	else
	{
		$next = "\<a href=\"display.cgi?show=$lownext-$highnext\&sort=$query{'sort'}\&game=".substr($query{'game'},0,-1)."\&order=$query{'order'}\&type=$query{'type'}\"\>Next $amount Scores\</a\>";
	}
}
else
{
	$next = "\<a href=\"display.cgi?show=$lownext-$highnext\&sort=$query{'sort'}\&game=".substr($query{'game'},0,-1)."\&order=$query{'order'}\&type=$query{'type'}\"\>Next $amount Scores\</a\>";
}

########################################
# Make Code to Display Scores
########################################
for($count = $first; ($count <= $last) && ($count < $numberofscores); $count++)
{
	$rank = $count + 1;
	$temp=$ent;
	$temp =~ s/\<!--Rank--\>/$rank/gi;
	@pieces = split(/\|/,$scores[$count]);
	foreach $field (@fields)
	{
		$temp =~ s/\<!--$field--\>/$pieces[$number{$field}]/gi;
		#print "$field--$pieces[$number{$field}]<br>";
	}
	#$displayent =~ s/\n//gi;
	$temp =~ s/\<!--PERL(.*?)--\>/eval($1)/geis;
	$displayent = $displayent.$temp;
}

########################################
# Format and Display Page
########################################
if(substr($query{'order'},0,1) eq "a")
{
	$oorder = "d";
}
else
{
	$oorder = "a";
}
$main =~ s/\<!--OOrder--\>/$oorder/gi;
$main =~ s/\<!--OOrder(.*?)--\>/&oorder/gei;
$main =~ s/\<!--Order--\>/$query{'order'}/gi;
$main =~ s/\<!--Type--\>/$query{'type'}/gi;
$main =~ s/\<!--Show--\>/$query{'show'}/gi;
$main =~ s/\<!--Sort--\>/$query{'sort'}/gi;
$main =~ s/\<!--Current--\>/$query{'show'}/gi;
$main =~ s/\<!--Game--\>/substr($query{'game'},0,-1)/gei;
$main =~ s/\<!--Next--\>/$next/gi;
$main =~ s/\<!--Previous--\>/$previous/gi;
$main =~ s/\<!--Entries--\>/$displayent/gi;
$main =~ s/\<!--PERL(.*?)--\>/eval($1)/geis;
print "$main";

########################################
# Sort Subroutines
########################################
sub sort_strings
{
	my(@AArray) = split(/\|/,$a);
	my(@BArray) = split(/\|/,$b);
	return (uc($AArray[$number{$query{'sort'}}]) cmp uc($BArray[$number{$query{'sort'}}]));
}

sub sort_numbers
{
	my(@AArray) = split(/\|/,$a);
	my(@BArray) = split(/\|/,$b);
	return ($BArray[$number{$query{'sort'}}] <=> $AArray[$number{$query{'sort'}}]);
}

sub oorder
{
	if(lc($1) eq $query{'sort'})
	{
		if(substr($query{'order'},0,1) eq "a")
		{
			return "d";
		}
		else
		{
			return "a";
		}
	}
	else
	{
		return $query{'order'};
	}
}

End: